﻿using System;
using System.IO;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

using Google.Apis.Auth.OAuth2;
using Google.Apis.Books.v1;
using Google.Apis.Books.v1.Data;
using Google.Apis.Services;
using Google.Apis.Util.Store;


namespace GoogleCredentials_Test
{
	public class OAuth2_Test
	{
		public async Task<string> Run()
		{
			StringBuilder sbReturn = new StringBuilder();
			sbReturn.Append("*** API key test ***" + Environment.NewLine);
			sbReturn.Append("- 모든 서가 리스트 -" + Environment.NewLine);

			//인증 정보 가지고 오기 
			UserCredential credential;
			using (var stream = new FileStream("[다운받은 클라이언트 시크릿 파일].json", FileMode.Open, FileAccess.Read))
			{
				credential = await GoogleWebAuthorizationBroker.AuthorizeAsync(
					GoogleClientSecrets.Load(stream).Secrets,
					new[] { BooksService.Scope.Books },
					"user", CancellationToken.None, new FileDataStore("Books.ListMyLibrary"));
			}

			//OAuth 2.0 서비스 생성
			var service = new BooksService(new BaseClientService.Initializer()
			{
				HttpClientInitializer = credential,
				ApplicationName = "Books API Sample",
			});

			//클라이언트 시크릿의 정보를 토대로 데이터를 받아 온다.
			//var result = await service.Mylibrary.Bookshelves.List().ExecuteAsync();
			var result = await service.Bookshelves.List("[조회할 유저 키]").ExecuteAsync();


			if (null != result)
			{//결과가 있다.
			 //결과 정보를 출력한다.
				foreach (Bookshelf book in result.Items)
				{
					sbReturn.Append(string.Format("{0}({1})", book.Title, book.Id) + Environment.NewLine);
				}
			}

			sbReturn.Append(string.Format("- 총 {0}개 서가 -", result.Items.Count) + Environment.NewLine);

			return sbReturn.ToString();
		}
	}
}
