﻿using System;
using System.Text;
using System.Threading.Tasks;

using Google.Apis.Books.v1;
using Google.Apis.Books.v1.Data;
using Google.Apis.Services;
using Google.Apis.Auth.OAuth2;
using System.Security.Cryptography.X509Certificates;

namespace GoogleCredentials_Test
{
	public class ServiceAccount_Test
	{

		public async Task<string> Run()
		{
			StringBuilder sbReturn = new StringBuilder();
			sbReturn.Append("*** API key test ***" + Environment.NewLine);
			sbReturn.Append("- 모든 서가 리스트 -" + Environment.NewLine);

			//loading the Key file
			var certificate = new X509Certificate2(@"[다운받은 서비스 계정키].p12", "notasecret", X509KeyStorageFlags.Exportable);
			var credential = new ServiceAccountCredential(new ServiceAccountCredential.Initializer("[키를 만들때 등록한 이메일]")
			{
				Scopes = new string[] { BooksService.Scope.Books },
			}.FromCertificate(certificate));

			//북서비스생성
			//OAuth 2.0 서비스 생성
			var service = new BooksService(new BaseClientService.Initializer()
			{
				HttpClientInitializer = credential,
				ApplicationName = "Books API Sample",
			});

			//조회할 사용자 정보 입력
			//var result = await service.Mylibrary.Bookshelves.List().ExecuteAsync();
			var result = await service.Bookshelves.List("[조회할 유저 키]").ExecuteAsync();

			if (null != result)
			{//결과가 있다.
			 //결과 정보를 출력한다.
				foreach (Bookshelf book in result.Items)
				{
					sbReturn.Append(string.Format("{0}({1})", book.Title, book.Id) + Environment.NewLine);
				}
			}

			sbReturn.Append(string.Format("- 총 {0}개 서가 -", result.Items.Count) + Environment.NewLine);

			return sbReturn.ToString();

		}
	}
}
